# Assessing Cities' Labour Market Efficiences using Mumbai Commuting Data

### Abstract of Paper
Ease of mobility is crucial for cities’ productivity. Better mobility allows better access to jobs and allows firms access to a larger pool of workers. As cities grow, congestion can rapidly erode productivity as well as impose heavy environmental costs. We use publicly-available Uber Movement data to measure congestion across 40 key routes connecting major Mumbai residential areas to the city’s key business districts. We go on to quantify the economic and environmental costs of congestion. We provide actionable results for policymakers by identifying chokepoints, specific route segments which contribute to congestion. Left unaddressed, the situation will have damaging effects on the potential benefits of agglomeration and, ultimately, Mumbai’s productivity.


### Appendix
The sections of the Appendix have been uploaded to this repository. They are outlined below:

Appendix A: Importance and historical evolution of Mumbai’s Central Business Districts

Appendix B: Commutes between residential areas and CBDs

Appendix C: Route-level TTIs

Appendix D: Additional Fuel, Emissions

Appendix E: Speeds for each segment across all analysed routes

Appendix F: Final Scripts

### Notes

IDs (Uber TAZs) for areas analysed:

Central Business Districts:
1. Bandra Kurla Complex: 182
2. Andheri East: 357
3. Lower Parel: 239
4. Malad: 350
5. Nariman Point: 382

Residential Areas:
1. Borivali (North Mumbai): 265
2. Marine Drive (South Mumbai): 577
3. Chembur (East Mumbai): 598 
4. Andheri West (West Mumbai): 403
